﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Microsoft.Win32;
using Microsoft.Crm.Sdk;
using Microsoft.Crm.SdkTypeProxy;

namespace AutoNumber
{
    public class PreCreateAccount : IPlugin
    {
        #region IPlugin Members

        public void Execute(IPluginExecutionContext context)
        {
            if (context.InputParameters.Properties.Contains("Target") && context.InputParameters.Properties["Target"] is DynamicEntity)
            {
                DynamicEntity entity = (DynamicEntity)context.InputParameters.Properties["Target"];
                string CurrentAutoNumber;

                if (entity.Name == EntityName.account.ToString())
                {
                    if (entity.Properties.Contains("accountnumber") == false)
                    {
                        lock (this)
                        {
                            RegistryKey regkey = Registry.LocalMachine.OpenSubKey("SOFTWARE\\Microsoft\\MSCRM");
                            string InstallDir = regkey.GetValue("CRM_Server_InstallDir").ToString() + @"\Server\bin\assembly\AccountAutoNumber.txt";

                            TextReader textReader = File.OpenText(InstallDir);
                            CurrentAutoNumber = textReader.ReadLine();
                            textReader.Close();
                            CurrentAutoNumber = (long.Parse(CurrentAutoNumber) + 1).ToString();
                            TextWriter textWriter = File.CreateText(InstallDir);
                            textWriter.WriteLine(CurrentAutoNumber);
                            textWriter.Close();
                        }

                        StringProperty accountNumber = new StringProperty("accountnumber", CurrentAutoNumber);
                        entity.Properties.Add(accountNumber);
                    }
                    else
                    {
                        throw new InvalidPluginExecutionException("自动编号只能由系统产生!");
                    }
                }
            }
        }

        #endregion
    }
}
